> ## Documentation Index
> Fetch the complete documentation index at: https://cobo.com/developers/llms.txt
> Use this file to discover all available pages before exploring further.

# Register webhook endpoint

> This operation registers a new webhook endpoint for your organization.

<Tip>
  Try [Cobo WaaS Skill](/v2/guides/overview/cobo-waas-skill) in your AI coding assistant (Claude Code, Cursor, etc.). Describe your needs in natural language to auto-generate production-ready SDK code and debug faster 🚀
</Tip>

<RequestExample>
  ```python Python theme={null}
  import cobo_waas2
  from cobo_waas2.models.create_webhook_endpoint_request import (
      CreateWebhookEndpointRequest,
  )
  from cobo_waas2.models.webhook_endpoint import WebhookEndpoint
  from cobo_waas2.rest import ApiException
  from pprint import pprint

  # See configuration.py for a list of all supported configurations.
  configuration = cobo_waas2.Configuration(
      # Replace `<YOUR_PRIVATE_KEY>` with your private key
      api_private_key="<YOUR_PRIVATE_KEY>",
      # Select the development environment. To use the production environment, change the URL to https://api.cobo.com/v2.
      host="https://api.dev.cobo.com/v2",
  )
  # Enter a context with an instance of the API client
  with cobo_waas2.ApiClient(configuration) as api_client:
      # Create an instance of the API class
      api_instance = cobo_waas2.DevelopersWebhooksApi(api_client)
      create_webhook_endpoint_request = cobo_waas2.CreateWebhookEndpointRequest(
          url="https://example.com/webhook",
          subscribed_events=["wallets.transaction.created"],
      )

      try:
          # Register webhook endpoint
          api_response = api_instance.create_webhook_endpoint(
              create_webhook_endpoint_request=create_webhook_endpoint_request
          )
          print("The response of DevelopersWebhooksApi->create_webhook_endpoint:\n")
          pprint(api_response)
      except Exception as e:
          print(
              "Exception when calling DevelopersWebhooksApi->create_webhook_endpoint: %s\n"
              % e
          )

  ```

  ```java Java theme={null}
  // Import classes:
  import com.cobo.waas2.ApiClient;
  import com.cobo.waas2.ApiException;
  import com.cobo.waas2.Configuration;
  import com.cobo.waas2.Env;
  import com.cobo.waas2.api.DevelopersWebhooksApi;
  import com.cobo.waas2.model.*;
  import java.util.Arrays;

  public class Example {
    public static void main(String[] args) {
      ApiClient defaultClient = Configuration.getDefaultApiClient();
      // Select the development environment. To use the production environment, replace `Env.DEV` with
      // `Env.PROD
      defaultClient.setEnv(Env.DEV);

      // Replace `<YOUR_PRIVATE_KEY>` with your private key
      defaultClient.setPrivKey("<YOUR_PRIVATE_KEY>");
      DevelopersWebhooksApi apiInstance = new DevelopersWebhooksApi();
      CreateWebhookEndpointRequest createWebhookEndpointRequest =
          new CreateWebhookEndpointRequest()
              .url("https://example.com/webhook")
              .subscribedEvents(Arrays.asList(WebhookEventType.WALLETS_TRANSACTION_CREATED));
      try {
        WebhookEndpoint result = apiInstance.createWebhookEndpoint(createWebhookEndpointRequest);
        System.out.println(result);
      } catch (ApiException e) {
        System.err.println("Exception when calling DevelopersWebhooksApi#createWebhookEndpoint");
        System.err.println("Status code: " + e.getCode());
        System.err.println("Reason: " + e.getResponseBody());
        System.err.println("Response headers: " + e.getResponseHeaders());
        e.printStackTrace();
      }
    }
  }

  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	coboWaas2 "github.com/CoboGlobal/cobo-waas2-go-sdk/cobo_waas2"
  	"github.com/CoboGlobal/cobo-waas2-go-sdk/cobo_waas2/crypto"
  	"os"
  )

  func main() {
  	createWebhookEndpointRequest := *coboWaas2.NewCreateWebhookEndpointRequest("https://example.com/webhook", []coboWaas2.WebhookEventType{coboWaas2.WebhookEventType("wallets.transaction.created")})

  	configuration := coboWaas2.NewConfiguration()
  	// Initialize the API client
  	apiClient := coboWaas2.NewAPIClient(configuration)
  	ctx := context.Background()

  	// Select the development environment. To use the production environment, replace coboWaas2.DevEnv with coboWaas2.ProdEnv
  	ctx = context.WithValue(ctx, coboWaas2.ContextEnv, coboWaas2.DevEnv)
  	// Replace `<YOUR_PRIVATE_KEY>` with your private key
  	ctx = context.WithValue(ctx, coboWaas2.ContextPortalSigner, crypto.Ed25519Signer{
  		Secret: "<YOUR_PRIVATE_KEY>",
  	})
  	resp, r, err := apiClient.DevelopersWebhooksAPI.CreateWebhookEndpoint(ctx).
  		CreateWebhookEndpointRequest(createWebhookEndpointRequest).
  		Execute()
  	if err != nil {
  		fmt.Fprintf(
  			os.Stderr,
  			"Error when calling `DevelopersWebhooksAPI.CreateWebhookEndpoint``: %v\n",
  			err,
  		)
  		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
  	}
  	// response from `CreateWebhookEndpoint`: WebhookEndpoint
  	fmt.Fprintf(
  		os.Stdout,
  		"Response from `DevelopersWebhooksAPI.CreateWebhookEndpoint`: %v\n",
  		resp,
  	)
  }

  ```

  ```javascript JavaScript theme={null}
  const CoboWaas2 = require("@cobo/cobo-waas2");
  // Initialize the API client
  const apiClient = CoboWaas2.ApiClient.instance;
  // Select the development environment. To use the production environment, replace `Env.DEV` with `Env.PROD`
  apiClient.setEnv(CoboWaas2.Env.DEV);
  // Replace `<YOUR_PRIVATE_KEY>` with your private key
  apiClient.setPrivateKey("<YOUR_PRIVATE_KEY>");
  // Call the API
  const apiInstance = new CoboWaas2.DevelopersWebhooksApi();
  const opts = {
    CreateWebhookEndpointRequest:
      CoboWaas2.CreateWebhookEndpointRequest.constructFromObject({
        url: "https://example.com/webhook",
        subscribed_events: ["wallets.transaction.created"],
      }),
  };
  apiInstance.createWebhookEndpoint(opts).then(
    (data) => {
      console.log("API called successfully. Returned data: " + data);
    },
    (error) => {
      console.error(error);
    },
  );

  ```
</RequestExample>


## OpenAPI

````yaml post /webhooks/endpoints
openapi: 3.0.3
info:
  title: Cobo Wallet as a Service 2.0
  description: >
    The Cobo Wallet-as-a-Service (WaaS) 2.0 API is the latest version of Cobo's
    WaaS API offering. It enables you to access Cobo's full suite of crypto
    wallet technologies with powerful and flexible access controls. By
    encapsulating complex security protocols and streamlining blockchain
    interactions, this API allows you to concentrate on your core business
    activities without worrying about the safety of your assets. The WaaS 2.0
    API presents the following key features:


    - A unified API for Cobo's [all four wallet
    types](https://manuals.cobo.com/en/portal/introduction#an-all-in-one-wallet-platform)

    - Support for 80+ chains and 3000+ tokens

    - A comprehensive selection of webhook events

    - Flexible usage models for MPC Wallets, including [Organization-Controlled
    Wallets](https://manuals.cobo.com/en/portal/mpc-wallets/ocw/introduction)
    and [User-Controlled
    Wallets](https://manuals.cobo.com/en/portal/mpc-wallets/ucw/introduction)

    - Programmatic control of smart contract wallets such as Safe{Wallet} with
    fine-grained access controls

    - Seamlessly transfer funds across multiple exchanges, including Binance,
    OKX, Bybit, Deribit, and more


    For more information about the WaaS 2.0 API, see [Introduction to WaaS
    2.0](https://www.cobo.com/developers/v2/guides/overview/introduction).
  termsOfService: https://cobo.com/waas/tos/
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  contact:
    name: Cobo WaaS
    url: https://www.cobo.com/waas
    email: help@cobo.com
  version: 1.0.0
servers:
  - url: https://api.dev.cobo.com/v2
    description: Development environment
  - url: https://api.cobo.com/v2
    description: Production environment
security:
  - CoboAuth: []
tags:
  - name: Organizations
    description: Operations related to Organizations.
  - name: Wallets
    description: Operations related to all wallets.
  - name: Wallets - MPC Wallets
    description: Operations related to mpc wallet.
  - name: Wallets - Exchange Wallet
    description: Operations related to exchange wallet.
  - name: Wallets - Smart Contract Wallets
    description: Operations related to smart contract wallet.
  - name: Transactions
    description: Operations related to all transactions.
  - name: Developers - Webhooks
    description: Operations related to webhooks.
  - name: Stakings
    description: Operations related to staking.
  - name: OAuth
    description: Operations related to OAuth.
  - name: Developers
    description: Operations related to developers.
  - name: AddressBooks
    description: Operations related to address books.
  - name: TravelRule
    description: Operations related to travel rule.
  - name: GraphQL
    description: Operations related to executing GraphQL queries and mutations.
  - name: PrimeBroker
    description: Operations related to prime broker.
  - name: AppWorkflows
    description: Operations related to app workflow.
  - name: FeeStation
    description: Operations related to fee station.
  - name: Payment
    description: Operations related to payment.
  - name: Batch Payouts
    description: Operations related to batch payouts.
  - name: Tokenization
    description: Operations related to tokenization.
  - name: AutoSweep
    description: Operations related to auto sweep.
  - name: Compliance
    description: Operations related to compliance.
paths:
  /webhooks/endpoints:
    post:
      tags:
        - Developers - Webhooks
      summary: Register webhook endpoint
      description: This operation registers a new webhook endpoint for your organization.
      operationId: create_webhook_endpoint
      requestBody:
        $ref: '#/components/requestBodies/createWebhookEndpointBody'
      responses:
        '201':
          $ref: '#/components/responses/createWebhookEndpointResponse'
        4XX:
          $ref: '#/components/responses/badRequestError'
        5XX:
          $ref: '#/components/responses/internalServerError'
      security:
        - CoboAuth: []
        - OAuth2:
            - webhook.edit
components:
  requestBodies:
    createWebhookEndpointBody:
      description: The request body to register a webhook endpoint.
      content:
        application/json:
          schema:
            type: object
            required:
              - subscribed_events
              - url
            properties:
              url:
                description: The webhook endpoint URL.
                type: string
                format: url
                example: https://example.com/webhook
              subscribed_events:
                description: >
                  The event types you want to subscribe to for this webhook
                  endpoint. You can call [Get webhook event
                  types](https://www.cobo.com/developers/v2/api-references/developers--webhooks/get-webhook-event-types)
                  to retrieve all available event types.
                items:
                  $ref: '#/components/schemas/WebhookEventType'
                type: array
              description:
                description: The description of the webhook endpoint.
                type: string
                example: My webhook endpoint
  responses:
    createWebhookEndpointResponse:
      description: The request was successful.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/WebhookEndpoint'
    badRequestError:
      description: >-
        Bad request. Your request contains malformed syntax or invalid
        parameters.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    internalServerError:
      description: Internal server error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
  schemas:
    WebhookEventType:
      type: string
      enum:
        - wallets.transaction.created
        - wallets.transaction.updated
        - wallets.transaction.failed
        - wallets.transaction.succeeded
        - wallets.mpc.tss_request.created
        - wallets.mpc.tss_request.updated
        - wallets.mpc.tss_request.failed
        - wallets.mpc.tss_request.succeeded
        - wallets.addresses.created
        - wallets.created
        - wallets.token_listing.failed
        - wallets.token_listing.succeeded
        - mpc_vaults.created
        - fee_station.transaction.created
        - fee_station.transaction.updated
        - fee_station.transaction.failed
        - fee_station.transaction.succeeded
        - fee_station.fiat_transaction.created
        - wallet.token.enabled
        - wallet.chain.enabled
        - wallet.mpc.balance.updated
        - wallet.web3.balance.updated
        - wallet.token.disabled
        - wallet.chain.disabled
        - token.suspended.deposit
        - token.suspended.withdraw
        - payment.transaction.created
        - payment.transaction.late
        - payment.transaction.completed
        - payment.transaction.held
        - payment.transaction.failed
        - payment.status.updated
        - payment.order.status.updated
        - payment.refund.status.updated
        - payment.settlement.status.updated
        - payment.payout.status.updated
        - payment.address.updated
        - payment.subscription.status.updated
        - payment.charge.status.updated
        - payment.bulk_send.status.updated
        - payment.transaction.external.created
        - payment.transaction.external.completed
        - payment.transaction.settlement_network.created
        - payment.transaction.settlement_network.completed
        - compliance.disposition.status.updated
        - compliance.kyt.screenings.status.updated
        - compliance.kya.screenings.status.updated
      example: wallets.transaction.created
      description: >
        The event type. To learn the trigger condition of each event type, refer
        to [Webhook event types and event
        data](https://www.cobo.com/developers/v2/guides/webhooks-callbacks/webhook-event-type). 
    WebhookEndpoint:
      type: object
      description: The information about a webhook endpoint.
      required:
        - url
        - subscribed_events
        - created_timestamp
        - id
        - status
      properties:
        url:
          description: The webhook endpoint URL.
          maxLength: 500
          type: string
          format: url
          example: https://example.com/webhook
        subscribed_events:
          description: The event types subscribed by a webhook endpoint.
          items:
            $ref: '#/components/schemas/WebhookEventType'
          type: array
        created_timestamp:
          description: >-
            The time when the endpoint was registered, in Unix timestamp format,
            measured in seconds.
          type: integer
          format: int64
          example: 1701396866000
        endpoint_id:
          description: The webhook endpoint ID.
          type: string
          format: uuid
          example: 8f2e919a-6a7b-4a9b-8c1a-4c0b3f5b8b1f
        status:
          $ref: '#/components/schemas/WebhookEndpointStatus'
        description:
          description: The description of the webhook endpoint.
          type: string
          example: My webhook endpoint
    ErrorResponse:
      type: object
      description: The response of a failed request.
      required:
        - error_code
        - error_message
        - error_id
      properties:
        error_code:
          type: integer
          description: >-
            The error code. Refer to [Error codes and status
            codes](https://www.cobo.com/developers/v2/api-references/error-codes)
            for more details.
        error_message:
          type: string
          description: The error description.
        error_id:
          type: string
          description: >-
            The error log ID. You can provide the error ID when submitting a
            ticket to help Cobo to locate the issue.
          example: 0b6ddf19083c4bd1a9ca01bec44b24dd
    WebhookEndpointStatus:
      type: string
      enum:
        - STATUS_ACTIVE
        - STATUS_INACTIVE
        - STATUS_PENDING_ACTIVE
        - STATUS_PENDING_INACTIVE
        - STATUS_PENDING_UPDATE
        - STATUS_REJECT_ACTIVE
      example: STATUS_ACTIVE
      description: >
        The webhook endpoint status. Possible values include:

        - `STATUS_ACTIVE`: The endpoint is currently in use.

        - `STATUS_INACTIVE`: The endpoint has been revoked and can no longer
        receive webhook events.

        - `STATUS_PENDING_ACTIVE`: The request to create the endpoint is
        awaiting approval. After the approval, the endpoint will be available
        for use.

        - `STATUS_PENDING_INACTIVE`: The request to revoke the endpoint is
        awaiting approval. After the approval,the endpoint will no longer
        receive webhook events.

        - `STATUS_PENDING_UPDATE`: The request to update the endpoint is
        awaiting approval. After the approval, the endpoint will be updated.

        - `STATUS_REJECT_ACTIVE`: The request to create the endpoint has been
        rejected.
  securitySchemes:
    CoboAuth:
      type: apiKey
      in: header
      name: BIZ-API-KEY
      description: >
        The API key. For more details, refer to [API
        key](https://www.cobo.com/developers/v2/guides/overview/cobo-auth#api-key).


        In the API playground, enter your [API
        secret](https://www.cobo.com/developers/v2/guides/overview/cobo-auth#api-secret),
        and your API key will be accordingly calculated.
    OAuth2:
      type: oauth2
      description: >-
        The [Org Access
        Token](https://www.cobo.com/developers/v2/apps/org-access-tokens). Use
        this authorization method only if you are developing Cobo Portal Apps
        for installation and use across different organizations.
      flows:
        authorizationCode:
          authorizationUrl: https://auth.cobo.com/authorize
          tokenUrl: https://auth.cobo.com/oauth/token
          scopes:
            address_book.read: Read address book
            api_key.read: Read API key information
            callback.read: Read callback message
            callback.resend: Resend callback message
            wallet.create: Create wallet
            wallet.read: Read wallet information
            wallet.update: Update wallet information
            wallet.delete: Delete wallet information
            wallet.create_address: Create wallet address
            wallet.manage_utxo: Manage UTXO
            mpc_project.create: Create MPC project
            mpc_project.read: Read MPC project information
            mpc_project.update: Update MPC project information
            mpc_vault.create: Create MPC Vault
            mpc_vault.read: Read MPC Vault information
            mpc_vault.update: Update MPC Vault information
            mpc_key_group.create: Create MPC key group
            mpc_key_group.read: Read MPC key group information
            mpc_key_group.update: Update MPC key group information
            mpc_key_group.delete: Delete MPC key group information
            transaction.read: Read transaction information
            transaction.withdraw: Make withdrawals
            transaction.estimate_fee: Estimate transaction fee
            transaction.contract_call: Initiate contract calls
            transaction.message_sign: Initiate message signings
            transaction.stake: Stake assets
            transaction.unstake: Unstake assets
            transaction.unstake_withdraw: Withdraw unstaked assets
            transaction.manage: Manage ongoing transactions
            transaction.update: Update transaction notes
            travel_rule.read: Read travel rule information
            travel_rule.edit: Edit travel rule information
            webhook.read: Read webhook URLs/events
            webhook.edit: Edit webhook URLs
            webhook.resend: Resend webhook events
            payment_orders_payin.create: Create pay-in order
            payment_orders_payin.read: Read pay-in order information
            payment_orders_payin.update: Update pay-in order
            payment_orders_refund.create: Create payment refund order
            payment_orders_refund.read: Read payment refund order information
            payment_settlement.create: Create payment settlement request
            payment_settlement.read: Read payment settlement request information
            payment_merchant.create: Create payment merchant
            payment_merchant.read: Read payment merchant information
            payment_merchant.update: Update payment merchant
            payment_forced_sweep.create: Create payment force sweep request
            payment_forced_sweep.read: Read payment force sweep request information
            compliance_funds.refund: Refund compliance funds request
            compliance_funds.isolate: Isolate compliance funds request
            compliance_funds.unfreeze: Unfreeze compliance funds request
            compliance_funds.read: Read compliance funds request information
            compliance_kyt_review.update: Update KYT review status
            compliance_kyt_decisions.update: Update KYT decision status
            compliance_kyt_status.read: Read KYT screening status
            compliance_kya_screenings.create: Create KYA address screening requests
            compliance_kya_screenings.read: Read KYA address screening results

````